/**
 * Tecnología del ocio
 * Bloque 1, unidad didáctica 9
 * Práctica 4
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <cwiid.h>
#include <math.h>

cwiid_mesg_callback_t cwiid_callback; //Función para callback
cwiid_err_t error; //Función para errores

//Función para errores
void error(cwiid_wiimote_t *wiimote, const char *s, va_list ap) {
	if (wiimote != NULL) {printf("Error en el dispositivo %d: ", cwiid_get_id(wiimote));}
	vprintf(s, ap);
	printf("\n");
}

//Función de callback
void cwiid_callback(cwiid_wiimote_t *wiimote, int mesg_count, union cwiid_mesg mesg[], struct timespec *timestamp) {
	int i, j;
	int valido = 0;
	float x;

	//Bucle que recorre todos los mensajes incluidos en la llamada al callback
	for (i = 0; i < mesg_count; i++) {
		if (mesg[i].type == CWIID_MESG_IR) {
			for (j = 0; j < CWIID_IR_SRC_COUNT; j++) {
				if (mesg[i].ir_mesg.src[j].valid) {
					valido |= mesg[i].ir_mesg.src[j].valid;
					printf("(%d %d [%d]) ", mesg[i].ir_mesg.src[j].pos[CWIID_X], mesg[i].ir_mesg.src[j].pos[CWIID_Y], mesg[i].ir_mesg.src[j].size);
				}
			}
			if (valido) {printf("\n");}
		}
		else {
			printf("Tipo de mensaje no esperado\n");
		}
	}
}


int main(int argc, char *argv[]) {

	cwiid_wiimote_t* wiimote; //Gestor del wiimote
	bdaddr_t bdaddr; //Dirección Bluetooth del wiimote
	int salir = 0; //Variable para interrumpir la ejecución
	char tmp[256]; //Temporal para mostrar la dirección Bluetooth

	cwiid_set_err(error); //Asigno la función de error

	printf("Poner el wiimote en modo de descubrimiento (pulsar 1+2) y pulsar enter...\n");
	getchar();
	printf("Buscando...\n");
	bdaddr = *BDADDR_ANY; //Se aceptará la conexión de cualquier wiimote
	if (!(wiimote = cwiid_connect(&bdaddr, CWIID_FLAG_MESG_IFC))) { //Conexión y habilitación de envío de mensajes
		printf("No se pudo detectar wiimote\n");
	}
	else {
		//Conexión establecida
		ba2str(&bdaddr, tmp); //Traducción a cadena de caracteres de la dirección Bluetooth
		printf("Dirección Bluetooth del wiimote %i: %s\n", cwiid_get_id(wiimote), tmp);
		if (cwiid_set_mesg_callback(wiimote, cwiid_callback)) { //Establezco el callback
			printf("No se pudo establecer el callback\n");
		}
		else {
			cwiid_set_rpt_mode(wiimote, CWIID_RPT_IR);
			printf("Escribe x y pulsa enter para salir\n");
			while (!salir) {
				//Bucle principal, sólo espera
				if (getchar() == 'x') {salir = 1;}
			}
		}
		if (cwiid_disconnect(wiimote)) { //Desconexión del wiimote
			printf("Error al desconectar el wiimote\n");
		}
	}
	return 0;
}
